open Fthread;;

let sched1= create_scheduler ();;

let event : (unit Fthread.event_t) ref = ref (create_event sched1);;

let x = ref 1;;

let rec compteur _ =
  Printf.printf "\n--- Debut instant %d ---\n\n" !x; flush stdout;
  cooperate();
  x := !x +1;
  if !x < 12 then compteur 0
;;

let rec thread1 k =
  Printf.printf "1 -> Debut de boucle : k = %d\n" k; flush stdout;
  Printf.printf "1 -> Attente du signal\n"; flush stdout;
  await !event;
  Printf.printf "1 -> Signal recu\n"; flush stdout;
  generate !event;
  Printf.printf "1 -> Signal emis\n"; flush stdout;
  event := create_event sched1;
  if k < 10 then thread1 (k+1)
;;

let rec thread2 k =
  Printf.printf "2 -> Debut de boucle : k = %d\n" k; flush stdout;
  generate !event;
  Printf.printf "2 -> Signal emis\n"; flush stdout;
  event := create_event sched1;
  Printf.printf "2 -> Attente du signal\n"; flush stdout;
  await !event;
  Printf.printf "2 -> Signal recu\n"; flush stdout;
  if k < 10 then thread2 (k+1)
;;

let _ = 
  ignore (create_thread sched1 compteur 0);
  ignore (create_thread sched1 thread1 1);
  ignore (create_thread sched1 thread2 1);
  start_scheduler sched1;
  exit()
;;
