open Fthread;;

let sched1= create_scheduler ();;

let event = create_event sched1;;

let x = ref 1;;
let res = ref true;;

let rec compteur _ =
  Printf.printf "\n--- Debut instant %d ---\n\n" !x; flush stdout; 
  cooperate();
  x := !x +1;
  if !x < 12 then compteur 0
;;

let rec emet _ =
  Printf.printf "EMETTEUR -> Debut de boucle\n"; flush stdout; 
  generate_value event !x;
  Printf.printf "EMETTEUR -> Signal emis : %d\n" !x; flush stdout; 
  cooperate();
  if !x < 11 then emet 0
;;

let rec recept _ =
  Printf.printf "RECEPTEUR -> Debut de boucle\n"; flush stdout; 
  let v = get_value event in
    begin
      if v != !x then res := false;
      Printf.printf "RECEPTEUR -> Signal recu : %d\n" v; flush stdout
    end;
    cooperate();
    if !x < 11 then recept 0
;;

let reussi _ =
  cooperate_n 15;
  match !res with
      true -> Printf.printf "true !\n"
    | false -> Printf.printf "false !\n"
;;

let _ =
  ignore (create_thread sched1 compteur 0);
  ignore (create_thread sched1 recept 0);
  ignore (create_thread sched1 emet 0);
  ignore (create_thread sched1 reussi 0);
  start_scheduler sched1;
  exit()
;;
